-- SuitEntry: [count]={effect},[count]={effect},[count]={effect},[count]={effect},[count]={effect},[count]={effect},[count]={effect},[count]={effect},[count]={effect}
function GetsetsData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	
	local _L = {}
	
	local ultimateGear = {
		[610986] = {[1] = {7,661}, [2] = {12,5721,18,733},[3] = {25,790,18,14}},
		[610987] = {[1] = {7,661}, [2] = {12,5721,18,733},[3] = {25,790,19,14,18,1000,23,-4}},
		[610988] = {[1] = {7,661}, [2] = {12,5721,18,733},[3] = {25,790,19,14,18,1000,19,3}},
		[610989] = {[1] = {7,661}, [2] = {15,5721,20,733},[3] = {191,790,21,14,20,1000,21,3}},
		[610990] = {[1] = {7,661}, [2] = {15,5721,20,733},[3] = {150,5549,21,14,20,1000,149,6}},
		[610991] = {[1] = {7,734}, [2] = {12,6455},[3] = {25,849,43,17,19,29}},
		[610992] = {[1] = {7,734}, [2] = {12,6455},[3] = {25,849,23,-17,19,29,18,1500,23,-2}},
		[610993] = {[1] = {7,734}, [2] = {12,6455},[3] = {25,849,23,-17,19,29,18,1500,19,2}},
		[610994] = {[1] = {7,734}, [2] = {15,6455},[3] = {191,849,21,29,20,1500,21,2}},
		[610995] = {[1] = {7,734}, [2] = {150,5707},[3] = {191,849,21,29,20,1500,149,4}},
		[611006] = {[1] = {2,540,12,2040,18,420}, [2] = {161,12,162,8,173,6,19,5,18,1000}},
		[611007] = {[1] = {4,540,15,2040,20,420}, [2] = {163,12,162,6,21,5,20,1000}},
		[611008] = {[1] = {3,540,15,2040,20,420}, [2] = {162,12,164,8,21,5,20,1000,149,8}},
		[611009] = {[1] = {3,540,12,2040,22,420}, [2] = {162,12,173,6,19,5}},
		[611010] = {[1] = {6,540,12,2040,18,420}, [2] = {18,1100,165,12,173,8,19,5,18,1200}},
	}
		
	if (id > 610985 and id < 611011) then
		for a = 1,3 do
			_L["set"..a] = {}
			
			for i = 1,9 do
				if (ultimateGear[id] ~= nil and ultimateGear[id][a] ~= nil and ultimateGear[id][a][i] ~= nil and ultimateGear[id][a][i+1]) then
					local basetype = ultimateGear[id][a][i]
					local basetypeval = ultimateGear[id][a][i+1]
					
					if (basetype ~= nil and basetype ~= 0) then
						table.insert(_L["set"..a],basetype)
						table.insert(_L["set"..a],basetypeval)
					end
				end
				i = i+1
			end
			
		end
		
	else
		for a = 1, 9 do
			_L["set"..a] = {}
			for i = 1,3 do
				if GetObjectInfo(id,"basetype"..a.."_"..i) then
					local basetype = GetObjectInfo(id,"basetype"..a.."_"..i)
					local basetypeval = GetObjectInfo(id,"basetypevalue"..a.."_"..i)
					if basetype ~= 0 then
						table.insert(_L["set"..a],basetype)
						table.insert(_L["set"..a],basetypeval)
					end
				end
			end
		end
	end
	local result = {}
	for i = 1, 9 do 
		result[i] = _L["set"..i]
	end
	--if id == 610909 then -- 610909 set is wrong on database
	--	result[]
	--end
	return result
end
function GetimagesData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	
	local actfield
	if GetObjectInfo(id,"actfield"):lower():gsub("[\\]","/"):find("interface/icons/") then
		actfield = GetObjectInfo(id,"actfield"):lower():gsub("[\\]","/"):gsub("interface/icons/","")
	end
	return actfield
end
function Getshop_itemsData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	local items = {}
	for i = 1, 30 do
		local item = GetObjectInfo(id,"sellitemid"..i)
		local cost1 = {GetObjectInfo(id,"costtype1_"..i),GetObjectInfo(id,"sellcost1_"..i)}
		local cost2 = {GetObjectInfo(id,"costtype1_"..i),GetObjectInfo(id,"sellcost1_"..i)}
		if item ~= 0 then
			table.insert(items,{item,cost1,cost2})
		end
	end
	return items
end
function Getrecipe_itemsData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	
	local item1_normal = GetObjectInfo(id,"item1_normal")
	
	return item1_normal
end
function GetarchievementsData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	
	local eqtypes = {}
	for i = 1, 10 do
		if GetObjectInfo(id,"eqtype"..i) then
			local eqtype = GetObjectInfo(id,"eqtype"..i)
			if eqtype ~= 0 then
				local eqtypeval = GetObjectInfo(id,"eqtypevalue"..i)
				table.insert(eqtypes,eqtype)
				table.insert(eqtypes,eqtypeval)
			end
		end
	end
	
	return eqtypes
end
function GetBadgeData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	
	local exeqtypes = {}
	for i = 1, 10 do
		if GetObjectInfo(id,"exeqtype"..i) then
			local exeqtype = GetObjectInfo(id,"exeqtype"..i)
			if exeqtype ~= 0 then
				local exeqtypeval = GetObjectInfo(id,"exeqtypevalue"..i)
				table.insert(exeqtypes,exeqtype)
				table.insert(exeqtypes,exeqtypeval)
			end
		end
	end
	if #exeqtypes == 0 then exeqtypes = nil end
	return exeqtypes
end
function GetrefinesData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	
	local eqtypes = {}
	for i = 1, 10 do
		if GetObjectInfo(id,"eqtype"..i) then
			local eqtype = GetObjectInfo(id,"eqtype"..i)
			if eqtype ~= 0 then
				local eqtypeval = GetObjectInfo(id,"eqtypevalue"..i)
				table.insert(eqtypes,eqtype)
				table.insert(eqtypes,eqtypeval)
			end
		end
	end
	local base = GetObjectInfo(id,"exeqpowerrate")
	
	return {eqtypes,base}
end
function GetitemsData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	
	local slot = GetObjectInfo(id,"armorpos") or GetObjectInfo(id,"weaponpos")
	local type = GetObjectInfo(id,"armortype") or GetObjectInfo(id,"weapontype")
	local limitlv = GetObjectInfo(id,"limitlv")
	local imageid = GetObjectInfo(id,"imageid")
	local refinetableid = GetObjectInfo(id,"refinetableid")
	local durable = GetObjectInfo(id,"durable")
	local eqtypes = {}
	for i = 1, 10 do
		if GetObjectInfo(id,"eqtype"..i) then
			local eqtype = GetObjectInfo(id,"eqtype"..i)
			if eqtype ~= 0 then
				local eqtypeval = GetObjectInfo(id,"eqtypevalue"..i)
				table.insert(eqtypes,eqtype)
				table.insert(eqtypes,eqtypeval)
			end
		end
	end
	local stats = {}
	for i = 1, 6 do
		if GetObjectInfo(id,"dropability"..i) then
			local stat = GetObjectInfo(id,"dropability"..i)
			if stat < 700000 and stat ~= 0 then
				table.insert(stats,stat)
			end
		end
	end
	if #stats == 0 then stats = nil end
	local suitid = GetObjectInfo(id,"suitid") ~= 0 and GetObjectInfo(id,"suitid") or nil
	local sexorspeed
	if GetObjectInfo(id,"armorpos") then
		local slotMatch = {
			1,2,3,4,5,6,7,8,11,13,16,12,21
		}
		sexorspeed = GetObjectInfo(id,"limitsex") ~= -1 and GetObjectInfo(id,"limitsex") or nil
		slot = slotMatch[slot] or slot
	else
		sexorspeed = GetObjectInfo(id,"attackspeed")
		type = type + 8
		slot = slot + 32
	end
	return {slot,type,limitlv,imageid,refinetableid,durable,eqtypes,stats,suitid,sexorspeed}
end
function Getspell_effectsData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	
	local ability_skilllvarg = GetObjectInfo(id,"ability_skilllvarg")
	local eqtypes = {}
	for i = 1, 10 do
		if GetObjectInfo(id,"eqtype"..i) then
			local eqtype = GetObjectInfo(id,"eqtype"..i)
			if eqtype ~= 0 then
				local eqtypeval = GetObjectInfo(id,"eqtypevalue"..i)
				table.insert(eqtypes, eqtype)
				table.insert(eqtypes, eqtypeval)
			end
		end
	end
	local effecttime = GetObjectInfo(id,"effecttime")
	local effecttime_skilllvarg = GetObjectInfo(id,"effecttime_skilllvarg")
	local atk_dmgpower = GetObjectInfo(id,"atk_dmgpower")
	local dmgpower_skilllvarg = GetObjectInfo(id,"dmgpower_skilllvarg")
	local atk_fixvalue = GetObjectInfo(id,"atk_fixvalue")
	local dotbase = GetObjectInfo(id,"dotbase")
	local dot_skilllvarg = GetObjectInfo(id,"dot_skilllvarg")
	local magicshield_point = GetObjectInfo(id,"magicshield_point")
	local magicshield_skilllvarg = GetObjectInfo(id,"magicshield_skilllvarg")
	return {
	ability_skilllvarg,eqtypes,effecttime,effecttime_skilllvarg,
	atk_dmgpower,dmgpower_skilllvarg,atk_fixvalue,dotbase,
	dot_skilllvarg,magicshield_point,magicshield_skilllvarg
	}
end
function GetcardsData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	
	local cardaddpower = GetObjectInfo(id,"cardaddpower")
	
	return cardaddpower
end
function GetskillsData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	
	local effecttype = GetObjectInfo(id,"effecttype")
	local imageid = GetObjectInfo(id,"imageid")
	local magicbases = {}
	for i = 1, 12 do
		local magicbase = GetObjectInfo(id,"magicbaseid"..i)
		magicbases[i] = magicbase
	end
	local maxskilllv = GetObjectInfo(id,"maxskilllv")
	if maxskilllv == 0 then
		return {effecttype,imageid,magicbases}
	else
		maxskilllv = maxskilllv == 100 and GetPlayerMaxLevel() or maxskilllv
		maxskilllv = maxskilllv == 50 and 55 or maxskilllv
		local exptablerate = GetObjectInfo(id,"exptablerate")
		return {effecttype,imageid,magicbases,maxskilllv,exptablerate}
	end
end
function GetShopItemData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	local items = {}
	for i = 1, 30 do
		local item = GetObjectInfo(id,"sellitemid"..i)
		if item ~= 0 then
			table.insert(items,item)
		end
	end
	return items,guid
end
function GetbonusData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	
	local eqtypes = {}
	for i = 1, 10 do
		if GetObjectInfo(id,"eqtype"..i) then
			local eqtype = GetObjectInfo(id,"eqtype"..i)
			if eqtype ~= 0 then
				local eqtypeval = GetObjectInfo(id,"eqtypevalue"..i)
				table.insert(eqtypes,eqtype)
				table.insert(eqtypes,eqtypeval)
			end
		end
	end
	local statParse = TEXT("Sys"..id.."_name"):gsub(" [XIVMCD]+$","")

	local group = 1
	if id >= 520000 then
		group = 10000
		if not Charplan.groupedRunes[statParse] then
			for i,v in pairs(Charplan.groupedRunes) do
				if next(Charplan.groupedRunes,i) then
					group = group + 1
				else
					Charplan.groupedRunes[statParse] = group
					break;
				end
			end
		else
			group = Charplan.groupedRunes[statParse]
		end
	else
		if not Charplan.groupedStats[statParse] then
			for i,v in pairs(Charplan.groupedStats) do
				if next(Charplan.groupedStats,i) then
					group = group + 1
				else
					Charplan.groupedStats[statParse] = group
					break;
				end
			end
		else
			group = Charplan.groupedStats[statParse]
		end
	end
	return {eqtypes,group}
end
function GetISSData(id)
	local guid = GetObjectInfo(id,"guid")
	if not guid then return end
	local skills = {}
	for i = 1, 4 do
		local skill = GetObjectInfo(id,"suitiskilld"..i)
		if skill ~= 0 then
			table.insert(skills,skill)
		end
	end
	return skills,guid
end
